package SevenZip.Compression.RangeCoder;

public class BitEncoder {
    static final int kNumBitModelTotalBits = 11;
    static final int kBitModelTotal = (1 << kNumBitModelTotalBits);
    static final int kNumMoveBits = 5;
    static final int kNumMoveReducingBits = 2;
    public static final int kNumBitPriceShiftBits = 6;
    
    int Prob;
    
    public void Init() { Prob = kBitModelTotal >> 1; }
    
    public void Encode(Encoder encoder, int symbol) throws java.io.IOException {
        int newBound = (encoder.Range >>> kNumBitModelTotalBits) * Prob;
        if (symbol == 0) {
            encoder.Range = newBound;
            Prob += (kBitModelTotal - Prob) >> kNumMoveBits;
        } else {
            encoder.Low += (newBound & 0xFFFFFFFFL);
            encoder.Range -= newBound;
            Prob -= (Prob) >> kNumMoveBits;
        }
        if ((encoder.Range & Encoder.kTopValueMask) == 0) // (encoder.Range < Encoder.kTopValue) {
        {
            encoder.Range <<= 8;
            encoder.ShiftLow();
        }
    }
    
    private static int[] ProbPrices = new int[kBitModelTotal >> kNumMoveReducingBits];
    
    static final int kNumBits = (kNumBitModelTotalBits - kNumMoveReducingBits);
    
    static {
        for (int i = kNumBits - 1; i >= 0; i--) {
            int start = 1 << (kNumBits - i - 1);
            int end = 1 << (kNumBits - i);
            for (int j = start; j < end; j++)
                ProbPrices[j] = (i << kNumBitPriceShiftBits) + (((end - j) << kNumBitPriceShiftBits) >> (kNumBits - i - 1));
        }
    }
    
    public int GetPrice(int symbol) {
        return ProbPrices[(((Prob - symbol) ^ ((-symbol))) & (kBitModelTotal - 1)) >> kNumMoveReducingBits];
    }
}

