package SevenZip.Compression.RangeCoder;
//import java.io.InputStream;
public	class Decoder {
    static final int kNumTopBits = 24;
    public static final int kTopValue = (1 << kNumTopBits);
    public static final int kTopValueMask = ~(kTopValue-1);
    int Range;
    int Code;
    public java.io.InputStream Stream;
    
    public final void Init(java.io.InputStream stream) throws java.io.IOException {
        Stream = stream;  // Stream.Init(stream);
        Code = 0;
        Range = -1; // (int)0xFFFFFFFFL;
        for (int i = 0; i < 5; i++)
            Code = (Code << 8) | Stream.read();
    }
    
    public final void ReleaseStream() {
        Stream = null;
    }
    public final int DecodeDirectBits(int numTotalBits) throws java.io.IOException {
        int result = 0;
        for (int i = numTotalBits; i > 0; i--) {
            Range >>>= 1;
            int t = ((Code - Range) >>> 31);
            Code -= Range & (t - 1);
            result = (result << 1) | (1 - t);
            
            if (Range < kTopValue) // because of "Range >>>= 1",   0 <= Range <= 0x7FFFFFFF
            {
                Code = (Code << 8) | Stream.read();
                Range <<= 8;
            }
        }
        return result;
    }
}

